

//------------teleport code by sparky-----------
//-------------V1.4.1-----------------------------
//---------special effects by TseTse-----------
//---this is where I create the triggers and put them right over the nexus base's

$playerreject = 6;

function createNewTeleportTriggers()
{

// get groupid

   $teleportgroup = nametoid(teleporters);

//----get all objects in group------

    %telecount = $teleportgroup.getcount();
       for ( %i = 0; %i < $teleportgroup.getCount(); %i++ )
          {
             %tp = $teleportgroup.getObject( %i );
                %trigger = new Trigger() 
                {
                   dataBlock = NewTeleportTrigger;
                   polyhedron = "-0.75 0.75 0.1 1.5 0.0 0.0 0.0 -1.5 0.0 0.0 0.0 2.3";
                };

            MissionCleanup.add(%trigger);
            %trigger.setTransform(%tp.getTransform());
            %trigger.targetbase = %tp.targetbase;
            %trigger.team = %tp.team;
	        %trigger.motherObj = %tp;     // tag relative object
	        %trigger.sourcebase = %tp;     // tag relative object
            %trigger.message = %tp.message;
            %trigger.logoscale = %tp.logoscale;
            %trigger.noflag = %tp.noflag;
            %trigger.oneway = %tp.oneway;
            %tp.trigger = %trigger;

            %tp.playThread(1, "ambient");
            %tp.playThread(0, "transition");


           if(getT2VersionNumber() $= "23669")
               {
               %newHolo = $holoName[%trigger.team] @ "Logo";
                %teleholo1 = $holoName[1] @ "Logo";
                %teleholo2 = $holoName[2] @ "Logo";
                }
                
            else
            {
            %newHolo = getTaggedString(game.getTeamSkin(%trigger.team)) @ "Logo";
                %teleholo1 = getTaggedString(game.getTeamSkin(1)) @ "Logo";
                %teleholo2 = getTaggedString(game.getTeamSkin(2)) @ "Logo";
              }

//            %newHolo = "testLogo";
            %pos = %trigger.position;

       if(%trigger.logoscale !$= "")
          {
             if(%trigger.team == 0)
                {
                      %team0holo1 = new StaticShape()
             {
             rotation = "0 0 3.14 0";
             position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 0.3;
             dataBlock = %teleholo1;
             scale = %trigger.logoscale;
             };
                      %team0holo2 = new StaticShape()
             {
             rotation = "0 0 0 0";
             position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 2.3;
             dataBlock = %teleholo2;
             scale = %trigger.logoscale;
             };

             MissionCleanup.add(%team0holo1);
             MissionCleanup.add(%team0holo2);

             }

         %holo = new StaticShape()
             {
             rotation = rotfromtransform(%trigger.gettransform());
             position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 1;
             dataBlock = %newHolo;
             scale = %trigger.logoscale;
             };
      // dump the hologram into MissionCleanup
             MissionCleanup.add(%holo);
      // associate the holo with the projector
          }

  if(%tp.waypoint !$= "")
      {
		%wp =	new WayPoint()
            {
				scale = "1 1 1";
				nameTag = %tp.waypoint;
				dataBlock = "WayPointMarker";
				lockCount = "0";
				homingCount = "0";
				name = %tp.waypoint;
			};

            MissionCleanup.add(%wp);
            %wp.setTransform(%tp.getTransform());
         }
         
         
     }
}

activatePackage(NewTeleport);

datablock TriggerData(NewTeleportTrigger)
{
   tickPeriodMS = 30;
};
//--------------teleporter code here------------------

createNewTeleportTriggers();


package NewTeleport {

function setPlayersPosition2(%data, %obj, %trigger, %colObj)
{
   %vel = getWords(%colObj.getVelocity(), 0, 1) @ " 0";
   if((VectorLen(%vel) < 22) && (%obj.triggeredBy != %colObj))
   {
      %pos = %trigger.position;
      %colObj.setvelocity("0 0 0");
	   %rot = getWords(%colObj.getTransform(),3, 6);
      %colObj.setTransform(getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 0.8 @ " " @ %rot);  //center player on object  
      %colObj.setMoveState(true);
//      %colObj.schedule(1300,"setMoveState", false);
//
//      %colObj.schedule(1300,"setvelocity" , "5 5 5");
      return true;
   }
   return false;
}

function NewTeleportTrigger::onEnterTrigger(%data, %trigger, %player)
{
 %colObj = %player;
      %client = %player.client;


  if(%player.transported $= "1")  // if this player was just transported
   {
   %player.transported = "0";
   %colObj.setMoveState(false);
   %player.llamathread = schedule(3000,0,"playerdamage",%player, true);
//   %player.setvelocity("5 5 5");
   return; // then get out or it will never stop
   }
//--------------are we on the right team?-----------------------
              if(%player.team != %trigger.team)
                   {
                     if(%trigger.team != 0)
                       {
                        %playervelocity = vectorscale(vectornormalize(%player.getvelocity()), 0.5);
                        %xv = getword(%playervelocity, 0);
		                %yv = getword(%playervelocity, 1);
                        %zv = getword(%playervelocity, 2);

                            if(getSubStr(%xv,0,1) !$= "-")
                            %xv = "-" @ %xv + $playerreject;
                            else
                               %xv = getsubstr(%xv,1,strlen(%xv - 1)) + $playerreject;

                            if(getSubStr(%yv,0,1) !$= "-")
                            %yv = "-" @ %yv + $playerreject;
                            else
                               %yv = getsubstr(%yv,1,strlen(%yv - 1)) + $playerreject;

                            if(getSubStr(%zv,0,1) !$= "-")
                            %zv = "-" @ %zv + $playerreject;
                            else
                               %zv = getsubstr(%zv,1,strlen(%zv - 1)) + $playerreject;

                       %player.setVelocity(%xv SPC %yv SPC %zv );
         //apply a "bounce" impulse to the player
//         %velocity = %player.getVelocity();
//         if (VectorDist("0 0 0", %velocity) < 2)
//            %velocityNorm = "0 8 0";
//         else
//            %velocityNorm = VectorScale(VectorNormalize(%velocity), 8);
//         %vector = VectorScale(%velocityNorm, $playerreject);
//         %player.applyImpulse(%player.position, %vector);

//                       %player.applyimpulse(posfromtransform(%player.gettransform()),%xv SPC %yv SPC %zv );
//                      %player.setVelocity("5 5 5");
                        messageClient(%Player.client, 'MsgClient', "\c0Wrong team.");
                        %player.llamathread = schedule(1000,0,"playerdamage",%player, true);
                        return;
                        }
                    }


//------------are we teleporting?-----------------------
 if(%trigger.teleporting == "1")
    {
                        %playervelocity = vectorscale(vectornormalize(%player.getvelocity()), 0.5);
                        %xv = getword(%playervelocity, 0);
		                %yv = getword(%playervelocity, 1);
                        %zv = getword(%playervelocity, 2);

                            if(getSubStr(%xv,0,1) !$= "-")
                            %xv = "-" @ %xv + $playerreject;
                            else
                               %xv = getsubstr(%xv,1,strlen(%xv - 1)) + $playerreject;

                            if(getSubStr(%yv,0,1) !$= "-")
                            %yv = "-" @ %yv + $playerreject;
                            else
                               %yv = getsubstr(%yv,1,strlen(%yv - 1)) + $playerreject;

                           if(getSubStr(%zv,0,1) !$= "-")
                            %zv = "-" @ %zv + $playerreject;
                            else
                               %zv = getsubstr(%zv,1,strlen(%zv - 1)) + $playerreject;


                       %player.setVelocity(%xv SPC %yv SPC %zv );

    messageClient(%Player.client, 'MsgClient', "\c0Teleporter in use.");
//    %player.setvelocity("1 1 1");
    return;
    }
//-------------is this a oneway teleporter?------------------------
 if(%trigger.oneway == "1")
    {
                        %playervelocity = vectorscale(vectornormalize(%player.getvelocity()), 0.5);
                        %xv = getword(%playervelocity, 0);
		                %yv = getword(%playervelocity, 1);
                        %zv = getword(%playervelocity, 2);

                            if(getSubStr(%xv,0,1) !$= "-")
                            %xv = "-" @ %xv + $playerreject;
                            else
                               %xv = getsubstr(%xv,1,strlen(%xv - 1)) + $playerreject;

                            if(getSubStr(%yv,0,1) !$= "-")
                            %yv = "-" @ %yv + $playerreject;
                            else
                               %yv = getsubstr(%yv,1,strlen(%yv - 1)) + $playerreject;

                           if(getSubStr(%zv,0,1) !$= "-")
                            %zv = "-" @ %zv + $playerreject;
                            else
                               %zv = getsubstr(%zv,1,strlen(%zv - 1)) + $playerreject;


                       %player.setVelocity(%xv SPC %yv SPC %zv );

      messageClient(%player.client, 'MsgLeaveMissionArea', '\c1This teleporter is oneway only.~wfx/misc/warning_beep.wav');
//    %player.setvelocity("1 1 1");
    return;
    }

//-------------are we teleporting with flag?----------------------------------------

     %flag = %player.holdingflag;

        if(%player.holdingFlag > 0)
          {
          if(%trigger.noflag $= "1")
             {
   if(%flag.team == 1)
      %otherTeam = 2;
   else
      %otherTeam = 1;
            game.flagReset(%player.holdingflag);
      messageTeam(%otherTeam, 'MsgCTFFlagReturned', '\c2 %1 tried to teleport with the %2 flag.~wfx/misc/flag_return.wav', %client.name, $teamName[%flag.team], %flag.team);
      messageTeam(%flag.team, 'MsgCTFFlagReturned', '\c2Your flag was returned.~wfx/misc/flag_return.wav', 0, 0, %flag.team);
      messageTeam(0, 'MsgCTFFlagReturned', '\c2The %2 flag was returned to base.~wfx/misc/flag_return.wav', 0, $teamName[%flag.team], %flag.team);
            }
          }

        setPlayersPosition2(%data, %obj, %trigger, %colObj);




//      nametoid(%trigger.targetbase).setThreadDir(1, %trigger.targetbase.flashThreadDir);


           %player.transported = "1";

           if(%trigger.message !$= "")
      	           messageClient(%Player.client, 'MsgClient', "\c0 " @ %trigger.message);

           %rot = rotFromTransform( %player.getTransform() );
           %player.setCloaked(true);
           teleporteffect(posfromtransform(%player.gettransform()));
           %pos = posFromTransform( nametoid(%trigger.targetbase).getTransform() );

		%x = getword(%pos, 0); 			// left of center
		%y = getword(%pos, 1);			// "forward" adjustment
		%z = getword(%pos, 2) + 1.6; 		// VERTICLE
		%exitpos = %x SPC %y SPC %z;		// new position
           teleporteffect(%exitpos);
           %trigger.teleporting = "1";
           %player.sourcetrigger = %trigger;
           %player.desttrigger =  nametoid(%trigger.targetbase).trigger;
           %player.desttrigger.teleporting = "1";
           %player.schedule(500, "settransform", %exitpos @ " " @ %rot);
           %player.schedule(500, "setCloaked", false);
//           %player.setvelocity("5 5 5");
//%player.takedamage = "1";



//-----hope this works?!?!?--------------------------------------------------


}

function NewTeleportTrigger::onleaveTrigger(%data, %trigger, %player)
{
if(%player.team !$= %trigger.team)
   cancel(%player.llamaThread);

if(%player.desttrigger == %trigger)
     {
   cancel(%player.llamaThread);
//           %player.takedamage = "0";
           %player.sourcetrigger.teleporting = "0";
           %player.desttrigger.teleporting = "0";
           %player.sourcetrigger = "0";
           %player.desttrigger = "0";
      }

      
      
      
 echo(%trigger.motherObj);
 echo(nametoid(%trigger.targetbase));
// echo(%player);
}

function NewTeleportTrigger::onTickTrigger(%data, %obj)
{
   Game.onTickTrigger(%obj.name, %data, %obj);
}

function teleporteffect(%position)
{
//       for ( %i = 0; %i < 4 %i++ )
//   {
           %pos = %position;
echo("the object is number " @ %obj );

	%effect1 = new ParticleEmissionDummy()
            {
		       position = %pos;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "AABulletExplosionEmitter2";
         		velocity = "1";
         	};
	%effect2 = new ParticleEmissionDummy()
            {
		       position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 0.5;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "AABulletExplosionEmitter2";
         		velocity = "1";
         	};
	%effect5 = new ParticleEmissionDummy()
            {
		       position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 0.75;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "flareEmitter";
         		velocity = "1";
         	};

	%effect3 = new ParticleEmissionDummy()
            {
		       position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 1;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "AABulletExplosionEmitter2";
         		velocity = "1";
         	};
	%effect4 = new ParticleEmissionDummy()
            {
		       position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 1.5;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "AABulletExplosionEmitter2";
         		velocity = "1";
         	};
            MissionCleanup.add(%effect1);
            MissionCleanup.add(%effect2);
            MissionCleanup.add(%effect3);
            MissionCleanup.add(%effect4);
            MissionCleanup.add(%effect5);
            %effect5.schedule(500, "delete");
            %effect1.schedule(2000, "delete");
            %effect2.schedule(2000, "delete");
            %effect3.schedule(2000, "delete");
            %effect4.schedule(2000, "delete");

}
function playerdamage(%this, %firstWarning)
{
%player = %this;

   if (!isObject(%player) || %player.getState() $= "Dead")
   {
    messageClient(%player.client, 'MsgClient', "\c0Camping on a teleporter is not cool.");
      return;
      }

      if(%firstwarning)
            {
      messageClient(%player.client, 'MsgLeaveMissionArea', '\c1Move off the teleporter or take damage.~wfx/misc/warning_beep.wav');
      %player.llamathread = schedule(3000,0,"playerdamage",%this, false);
       return;

            }
            

      %this.setdamageflash(0.3);

      %this.damage(0, %player.position, 0.04, $DamageType::radiation);


%player.llamathread = schedule(1000,0,"playerdamage",%this, false);


}


};
//Teleport code ends here----------------------------------------


